![Fluent](https://cloud.githubusercontent.com/assets/1342803/12735105/1bdfb1d0-c913-11e5-9b45-f7a6f7cba720.png)

# Fluent

Simple ActiveRecord implementation for working with your database in Swift.

- [x] Easy setup
- [x] Beautiful syntax
- [x] Generically typed

![Swift](https://camo.githubusercontent.com/0727f3687a1e263cac101c5387df41048641339c/68747470733a2f2f696d672e736869656c64732e696f2f62616467652f53776966742d332e302d6f72616e67652e7376673f7374796c653d666c6174)
[![Slack Status](http://qutheory.io:8001/badge.svg)](http://slack.qutheory.io)
[![Twitter Follow](https://img.shields.io/twitter/follow/shields_io.svg?style=social&label=Follow&maxAge=2592000)](https://twitter.com/qutheory)
[![PRs Welcome](https://img.shields.io/badge/prs-welcome-brightgreen.svg)](http://makeapullrequest.com)

Fluent is the first Swift ORM that works with both SQL and NoSQL. It provides a beautifully expressive and easy to use syntax for interacting with your database.

This repository is the framework's source code. To view a sample project, check out the [Fluent Example](https://github.com/qutheory/fluent-example).

Clone the [Example](https://github.com/qutheory/fluent-example) project to start making your application. If you are also looking for a web server, check out [Vapor](https://github.com/qutheory/vapor). It was built to work well with Fluent.

You must have Swift 3 or later installed. You can learn more about Swift 3 at [Swift.org](http://swift.org)

## 🌏 Environment

|Fluent|Xcode|Swift|
|:-:|:-:|:-:|
|0.8.x|8.0 Beta **3**|DEVELOPMENT-SNAPSHOT-2016-07-25-a|
|0.7.x|7.3.x|DEVELOPMENT-SNAPSHOT-2016-06-06-a|
|0.6.x|7.3.x|DEVELOPMENT-SNAPSHOT-2016-06-06-a|
|0.5.x|7.3.x|DEVELOPMENT-SNAPSHOT-2016-06-06-a|
|0.4.x|7.3.x|3.0-preview-1-SNAPSHOT-2016-05-31-a|
|0.3.x|7.3.x|DEVELOPMENT-SNAPSHOT-2016-05-03-a|
|0.2.x|7.3.x|DEVELOPMENT-SNAPSHOT-2016-03-01-a|

## 📖 Documentation

Visit the [Documentation](http://docs.qutheory.io) for extensive information on getting setup, using, and deploying Vapor. 

Fluent specific documentation is coming soon.

## 🚀 Contributing

To contribute a **feature or idea** to Fluent, submit an issue and fill in the template. If the request is approved, you or one of the members of the community can start working on it.

If you find a **bug**, please submit a pull request with a failing test case displaying the bug or create an issue.

If you find a **security vulnerability**, please contact [tanner@qutheory.io](tanner@qutheory.io) as soon as possible. We take these matters seriously.

## 💙 Code of Conduct

Our goal is to create a safe and empowering environment for anyone who decides to use or contribute to Fluent. Please help us make the community a better place by abiding to this [Code of Conduct](https://github.com/qutheory/vapor/blob/master/CODE_OF_CONDUCT.md) during your interactions surrounding this project. 

## 🔧 Compatibility

Vapor has been tested on OS X 10.11, Ubuntu 14.04, and Ubuntu 15.10. 

Our homepage [http://qutheory.io](http://qutheory.io) is currently running using Vapor + Fluent on DigitalOcean.

## ⚠️ Work in Progress

This is a work in progress, so *do not* rely on this for anything important. And pull requests are welcome!

## 👥 Authors

Made by [Tanner Nelson](https://twitter.com/tanner0101), [Logan Wright](https://twitter.com/logmaestro), and the hundreds of members of the Qutheory community.

